import 'package:flutter/material.dart';

import 'scale_scheme.dart';

export 'scale_color.dart';
export 'scale_input_decorator_theme.dart';
export 'scale_scheme.dart';
export 'scale_tile_theme.dart';
export 'scale_toast_theme.dart';

class ScaleTheme extends ThemeExtension<ScaleTheme> {
  ScaleTheme({
    required this.textTheme,
    required this.scheme,
    required this.config,
  });

  final TextTheme textTheme;
  final ScaleScheme scheme;
  final ScaleConfig config;

  @override
  ScaleTheme copyWith({
    TextTheme? textTheme,
    ScaleScheme? scheme,
    ScaleConfig? config,
  }) =>
      ScaleTheme(
        textTheme: textTheme ?? this.textTheme,
        scheme: scheme ?? this.scheme,
        config: config ?? this.config,
      );

  @override
  ScaleTheme lerp(ScaleTheme? other, double t) {
    if (other is! ScaleTheme) {
      return this;
    }
    return ScaleTheme(
        textTheme: TextTheme.lerp(textTheme, other.textTheme, t),
        scheme: scheme.lerp(other.scheme, t),
        config: config.lerp(other.config, t));
  }
}
